
/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2003 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Id$" NO-UNDO. 

/**********************************************************/
/* This doesn't work the greatest.  It doesn't know how   */
/* handle punctuation marks very well.                    */
/**********************************************************/

DEFINE INPUT PARAMETER cPhrase AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER cDictName  AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER cOutPhrase AS CHARACTER NO-UNDO.

DEFINE VARIABLE iNumWords AS INTEGER NO-UNDO.
DEFINE VARIABLE iCurWord  AS INTEGER NO-UNDO.
DEFINE VARIABLE cCurWord  AS CHARACTER NO-UNDO.
DEFINE VARIABLE cWordList AS CHARACTER NO-UNDO.

/**********************************************************/
/* In order for our replace to work well, we need a space */
/* before and after all the words.                        */
/**********************************************************/

ASSIGN cPhrase = " " + cPhrase + " ".

/**********************************************************/
/* Spell check the words one by one, replacing with the   */
/* list of possibles.  Note that the list returns the     */
/* word if the word is spelled correctly!                 */
/**********************************************************/

ASSIGN iNumWords = NUM-ENTRIES(cPhrase, " ").
ASSIGN cOutPhrase = cPhrase.

DO iCurWord = 1 TO iNumWords:

  ASSIGN cCurWord = ENTRY(iCurWord, cPhrase, " ").
  IF cCurWord = "" THEN NEXT.

  ASSIGN cWordList = "".
  RUN ChkWord.p (INPUT cCurWord, INPUT cDictName, OUTPUT cWordList).

  IF cWordList <> cCurWord THEN ASSIGN cWordList = "[" + cCurWord + "," + cWordList + "]".

  ASSIGN cOutPhrase = REPLACE(cOutPhrase, " " + cCurWord + " ", " " + cWordList + " ").

END. /* DO iCurWord = 1 TO iNumWords: */



